;===========================================================================
;				I2C bus hard driver
;
;===========================================================================
; 			   I2C
;---------------------------------------------------------------------------
IIC_init:
		ldi temp,5				;TWBR =((8000000/300000)-16)/(2*4^0)=5 300
	;	ldi temp,32				;TWBR =((8000000/100000)-16)/(2*4^0)=32 100
		OUT TWBR,temp			;   300  F  8 
		ldi temp, (0<<TWPS1)|(0<<TWPS0) 
		OUT TWSR,temp			;.  TWI  1 (TWPS=0)
		ret

;===========================================================================
; 				  
;---------------------------------------------------------------------------
IIC_Start:
		ldi temp,(1<<TWINT)|(1<<TWSTA)|(1<<TWEN) ;  
		OUT TWCR,temp
		rcall iic_wait					; ,   
		ret

;===========================================================================
; 				   
;---------------------------------------------------------------------------
IIC_Stop:
	ldi temp,(1<<TWINT)|(1<<TWEN)|(1<<TWSTO)	;  
	OUT TWCR,temp
	ret

;===========================================================================
; 				 .     temp
;---------------------------------------------------------------------------
iic_recieve:
	ldi temp,(1<<TWINT)|(1<<TWEN)|(1<<TWEA)	; 
	OUT TWCR,temp
	rcall iic_wait							;,   
	in temp,TWDR							; 
	ret

;===========================================================================
; 		   ( ACK).     temp
;---------------------------------------------------------------------------
iic_recieve_lst:
	ldi temp,(1<<TWINT)|(1<<TWEN)	;  
	OUT TWCR,temp					;
	rcall iic_wait					; ,    
	in temp,TWDR					;  
	ret

;===========================================================================
; 			 .     temp
;---------------------------------------------------------------------------
iic_send:
	out TWDR,temp					;  
	ldi temp,(1<<TWINT)|(1<<TWEN)	;  
	OUT TWCR,temp					; 
	rcall iic_wait					; ,    
	ret

;===========================================================================
; 					  
;---------------------------------------------------------------------------
IIC_Wait:
	in temp,TWCR			;    TWCR    temp
	sbrs temp,TWINT			;     1 -  
	rjmp IIC_Wait			;   ,   
	ret
;===========================================================================


.EXIT
